﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace BitTorrentSharp.Client
{
	/// <summary>
	/// Used in <see cref="PeerFriend.MessageReceived"/> event.
	/// </summary>
	public class MessageEventArgs : EventArgs
	{
		/// <summary>
		/// Get or set a value that indicates if the message has been handled.
		/// </summary>
		public bool Handled
		{
			get;
			set;
		}

		/// <summary>
		/// Get the raw message to be handled.
		/// </summary>
		public RawMessage Message
		{
			get;
			private set;
		}
	}
}
