﻿/*
 * NodeStateChangedEventArgs
 * 
 * Author: snowdreamist
 * Date: 2011/11/22
 * 
 */

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace BitTorrentSharp.DHT
{
    public class NodeStateChangedEventArgs : EventArgs
    {
        public NodeStateChangedEventArgs(Node node, NodeState oldState, NodeState newState)
        {
            if (node == null)
                throw new ArgumentNullException("node");
            this.Node = node;
            this.OldState = oldState;
            this.NewState = newState;
        }

        public Node Node { get; private set; }

        public NodeState OldState { get; private set; }

        public NodeState NewState { get; private set; }
    }
}
