﻿/*
 * DataWrapper
 * 
 * Author: snowdreamist
 * Date: 2011/11/25
 * 
 */

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using BitTorrentSharp.KRPC.Messages;

namespace BitTorrentSharp.KRPC.Contract
{
    public class DataContractWrapper
    {
        public DataContractWrapper(KRPCDataContractAttribute attr)
        {
            if (attr == null)
                throw new ArgumentNullException("attr");
            this.SerializerType = attr.SerializerType;
            this.SerializerFactoryType = attr.SerializerFactoryType;
        }
        /// <summary>
        /// Serializer type
        /// </summary>
        public Type SerializerType { get; private set; }
        /// <summary>
        /// Serializer factory type
        /// </summary>
        public Type SerializerFactoryType { get; private set; }
    }
}
