﻿/*
 * KRPCDataContractAttribute
 * 
 * Author: snowdreamist
 * Date: 2011/11/24
 * 
 */

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using BitTorrentSharp.KRPC.Messages;

namespace BitTorrentSharp.KRPC
{
    /// <summary>
    /// KRPC datacontract
    /// </summary>
    [AttributeUsage(AttributeTargets.Class, AllowMultiple = false, Inherited = false)]
    public class KRPCDataContractAttribute : Attribute
    {
        /// <summary>
        /// Serializer to serialize and deserialize this type
        /// Null means to use default serializer
        /// </summary>
        public Type SerializerType { get; set; }
        /// <summary>
        /// The type of factory which used to create serializer
        /// Null means to use default serializerFactory (specified in KRPCHost)
        /// </summary>
        public Type SerializerFactoryType { get; set; }
    }
}
