﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace BitTorrentSharp.Peers
{
	/// <summary>
	/// Represent as a message that a peer will chock the channel to another peer.
	/// </summary>
	public class ChockMessage : PeerNonKeepAliveMessage
	{
		/// <summary>
		/// Get the type of the message. This property always returns <see cref="PeerMessageType.Choke"/>.
		/// </summary>
		public override PeerMessageType Type
		{
			get
			{
				return PeerMessageType.Choke;
			}
		}

		/// <summary>
		/// Get the data sequence of this message.
		/// </summary>
		/// <returns>The data sequence of this message.</returns>
		protected override byte[] GetPayloadBytes()
		{
			return ByteHelper.EmptyData;
		}

		/// <summary>
		/// Initialize a new instance of the message.
		/// </summary>
		public ChockMessage()
		{

		}
	}
}
