﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace BitTorrentSharp.Peers
{
	/// <summary>
	/// Represent as the message that a peer is interested in another peer.
	/// </summary>
	public class InteresetedMessage : PeerNonKeepAliveMessage
	{
		/// <summary>
		/// Get the type of the message. This property always returns <see cref="PeerMessageType.Interested"/>.
		/// </summary>
		public override PeerMessageType Type
		{
			get
			{
				return PeerMessageType.Interested;
			}
		}

		/// <summary>
		/// Get the data sequence of this message.
		/// </summary>
		/// <returns>The data sequence of this message.</returns>
		protected override byte[] GetPayloadBytes()
		{
			return ByteHelper.EmptyData;
		}

		/// <summary>
		/// Initialize a new instance of the message.
		/// </summary>
		public InteresetedMessage()
		{

		}
	}
}
